#include "pangulu_common.h"
#include "pangulu_test.h"


int_t CPU_MEMORY=0;
int_t GPU_MEMORY=0;


#ifdef CHECK_TIME

double TIME_transport = 0.0;
double TIME_isend = 0.0;
double TIME_receive = 0.0;
double TIME_getrf = 0.0;
double TIME_tstrf = 0.0;
double TIME_gessm = 0.0;
double TIME_ssssm = 0.0;

struct timeval GET_TIME_START, GET_TIME_END;

#endif

int_32t RANK;
int_32t LEVEL;

void pangulu(int ARGC, char **ARGV)
{
    int_32t rank;
    int_32t size;

#ifndef OVERLAP
    MPI_Init(&ARGC, &ARGV);
#else
    int provided;
    MPI_Init_thread(&ARGC,&ARGV,MPI_THREAD_MULTIPLE,&provided);
#endif

    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    pangulu_common *common = (pangulu_common *)pangulu_malloc(sizeof(pangulu_common));
    common->rank = rank;
    common->size = size;
    RANK=rank;
    pangulu_get_common(common, ARGC, ARGV);
    pangulu_Smatrix *symbolic_Smatrix = (pangulu_Smatrix *)pangulu_malloc(sizeof(pangulu_Smatrix));
    pangulu_init_pangulu_Smatrix(symbolic_Smatrix);

    if (rank == 0)
    {
        pangulu_read_pangulu_Smatrix(symbolic_Smatrix, common->file_name);
        if(symbolic_Smatrix->row==0){
            printf("matrix read error row is 0\n");
            return ;
        }
        //pangulu_display_pangulu_Smatrix(symbolic_Smatrix);
    }
    
    pangulu_test(common, symbolic_Smatrix);
    
    if (rank == 0)
    {
        pangulu_destroy_part_pangulu_Smatrix(symbolic_Smatrix);
    }
    else{
        free(symbolic_Smatrix);
        symbolic_Smatrix=NULL;
    }  
    
    pangulu_destroy_pangulu_common(common);
    
    MPI_Finalize();
    return ;
}
