#ifndef PANGULU_TEST_H
#define PANGULU_TEST_H
/*An impoortant function is void pangulu_test(pangulu_common *common,
                      pangulu_Smatrix *symbolic_Smatrix){ }
It's parameters are explained as follows: 
common is the some parameters save in panguLU;
symbolic_matrix is Solve the matrix.
*/
#include "pangulu_common.h"
#include "pangulu_utils.h"
#include "pangulu_preprocess.h"
#include "pangulu_numerical.h"
#include "pangulu_check.h"
#include "pangulu_destroy.h"



    void pangulu_test(pangulu_common *common,
                      pangulu_Smatrix *symbolic_Smatrix)
    {

#ifdef CHECK_TIME
        pangulu_time_init();
#endif
                
        int_32t rank = common->rank;
        int_32t P = common->P;
        int_32t Q = common->Q;
        int_32t NB = common->NB;
        MPI_Barrier(MPI_COMM_WORLD);
        //printf("rank is %ld pid is %ld\n",rank,getpid());
        fflush(NULL);
        MPI_Barrier(MPI_COMM_WORLD);
        pangulu_time_start(common);
        common->N = pangulu_Bcast_N(symbolic_Smatrix->row, 0);
        int_t N = common->N;
        if (rank == 0)
        {
                printf("N is %ld ,NNZ is %ld\n", N, symbolic_Smatrix->rowpointer[N]);
                printf("now use four kernels in which device:\n");
                printf("GETRF:GPU\n");

#ifdef GPU_TSTRF
                printf("TSTRF:GPU\n");
#else
                printf("TSTRF:CPU\n");
#endif

#ifdef GPU_GESSM
                printf("GESSM:GPU\n");
#else
                printf("GESSM:CPU\n");
#endif

 
                printf("SSSSM:GPU\n");
#ifdef load_balance
                printf("load balance ------------------ ON  \n");
#else
                printf("load balance ------------------ OFF \n");
#endif

#ifdef OVERLAP
                printf("OVERLAP      ------------------ ON  \n");
#else
                printf("OVERLAP      ------------------ OFF \n");
#endif

                fflush(NULL);
        }

        pangulu_cuda_device_init(rank);
        
        pangulu_block_Smatrix *block_Smatrix=(pangulu_block_Smatrix *)pangulu_malloc(sizeof(pangulu_block_Smatrix));
        pangulu_block_common *block_common=(pangulu_block_common *)pangulu_malloc(sizeof(pangulu_block_common));
        block_common->rank=rank;
        block_common->P=P;
        block_common->Q=Q;
        block_common->NB=NB;
        block_common->N=N;
        block_common->block_length = pangulu_Calculate_Block(N, NB);
        block_common->sum_rank_size=common->sum_rank_size;
        block_common->max_PQ=PANGULU_MAX(P,Q);
        block_common->every_level_length=block_common->block_length;
        //block_common->every_level_length=30;
        

        if(rank==-1){
                pangulu_display_pangulu_Smatrix(symbolic_Smatrix);
        }

        //return ;
        MPI_Barrier(MPI_COMM_WORLD);
        pangulu_time_start(common);
        
        pangulu_preprocess(block_common,
                           symbolic_Smatrix,
                           block_Smatrix);
        
        MPI_Barrier(MPI_COMM_WORLD);
        pangulu_time_stop(common);
        
        //return ;
        
        if (rank==0)
        {
            printf("rank %d the preprocess time is %lf s\nCPU use MEMORY is %ld B GPU use MEMORY is %ld B\n", 
                   rank,pangulu_get_spend_time(common),CPU_MEMORY,GPU_MEMORY);
            fflush(NULL);
        }

#ifdef OVERLAP
        MPI_Barrier(MPI_COMM_WORLD);
        pangulu_time_start(common);

        pangulu_create_pthread(block_common,
                               block_Smatrix);

        MPI_Barrier(MPI_COMM_WORLD);
        pangulu_time_stop(common);
#endif        

        MPI_Barrier(MPI_COMM_WORLD);
        pangulu_time_start(common);

        pangulu_numerical(block_common,
                          block_Smatrix);

        MPI_Barrier(MPI_COMM_WORLD);
        pangulu_time_stop(common);

        //return ;
        
        if (rank==0)
        {
            printf("rank %d the numerical time is %lfs\n", rank,pangulu_get_spend_time(common));
        }

        pangulu_check(block_common,block_Smatrix,symbolic_Smatrix);
        MPI_Barrier(MPI_COMM_WORLD);

#ifdef CHECK_TIME
        pangulu_time_simple_output(rank);
        //pangulu_time_output(rank);
#endif
        //MPI_Barrier(MPI_COMM_WORLD);
        pangulu_destroy(block_common,block_Smatrix);
        //MPI_Barrier(MPI_COMM_WORLD);
        
        printf("pangulu_test---------------------------finish\n");
        free(block_common);
        block_common=NULL;
        free(block_Smatrix);
        block_Smatrix=NULL;
        return;
    }


#endif
