#ifndef PANGULU_TIME_H
#define PANGULU_TIME_H
/*
The function in this file checks the time of kernels,these functions would be called in pangulu_test.h,pangulu_preprocess.h,pangulu_numerical.h
*/


#include "pangulu_common.h"


    void pangulu_time_check_begin()
    {
        gettimeofday(&(GET_TIME_START), NULL);
    }

    double pangulu_time_check_end()
    {
        gettimeofday(&(GET_TIME_END), NULL);
        return ((GET_TIME_END.tv_sec - GET_TIME_START.tv_sec) * 1000.0 + (GET_TIME_END.tv_usec - GET_TIME_START.tv_usec) / 1000.0);
    }

    void pangulu_time_init()
    {
        TIME_transport = 0.0;
        TIME_isend = 0.0;
        TIME_receive = 0.0;
        TIME_getrf = 0.0;
        TIME_tstrf = 0.0;
        TIME_gessm = 0.0;
        TIME_ssssm = 0.0;
        return;
    }
    void pangulu_time_output(int_t rank)
    {
        printf("rank is %ld\n     \
            TIME_transport is %lf\n    \
                TIME_isend is %lf\n    \
                TIME_receive is %lf\n    \
                TIME_getrf is %lf\n    \
                TIME_tstrf is %lf\n    \
                TIME_gessm is %lf\n    \
                TIME_ssssm is %lf\n    ", 
                rank,
                TIME_transport ,
                TIME_isend ,
                TIME_receive ,
                TIME_getrf ,
                TIME_tstrf ,
                TIME_gessm ,
                TIME_ssssm );
    }

    void pangulu_time_simple_output(int_t rank)
    {
        printf("%ld\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t%lf\t\n", 
                rank,
                TIME_transport ,
                TIME_isend ,
                TIME_receive ,
                TIME_getrf ,
                TIME_tstrf ,
                TIME_gessm ,
                TIME_ssssm ,TIME_getrf + TIME_tstrf + TIME_gessm + TIME_ssssm);
    }



#endif