#ifndef PANGULU_TSTRF_FP64_H
#define PANGULU_TSTRF_FP64_H
/*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
#include "pangulu_common.h"
#include "pangulu_cuda_interface.h"

    void pangulu_tstrf_fp64(pangulu_Smatrix *A,
                            pangulu_Smatrix *X,
                            pangulu_Smatrix *U)
    {
        int_t *X_colpointer = A->columnpointer;
        int_t *X_rowindex = A->rowindex;
        calculate_type *X_value = A->value_CSC;
        int_t *U_rowpointer = U->rowpointer;
        int_t *U_columnindex = U->columnindex;
        calculate_type *U_value = U->value;
        int_t *A_colpointer = A->columnpointer;
        int_t *A_rowindex = A->rowindex;
        calculate_type *A_value = X->value_CSC;
        int_t n = A->row;

        for(int_t i=0;i<A->nnz;i++){
            X_value[i]=0.0;
        }
        for (int_t i = 0; i < n; i++)
        {
            calculate_type t = U_value[U_rowpointer[i]];
            if(t<ERROR&&t>-ERROR){
                t=ERROR;
            }
            for (int_t k = A_colpointer[i]; k < A_colpointer[i + 1]; k++)
            {
                X_value[k] = A_value[k] / t;
            }
            //update Value
            if (A_colpointer[i] != A_colpointer[i + 1])
                for (int_t k = U_rowpointer[i]; k < U_rowpointer[i + 1]; k++)
                {
                    int_t p = X_colpointer[i];
                    for (int_t s = A_colpointer[U_columnindex[k]]; s < A_colpointer[U_columnindex[k] + 1]; s++)
                    {
                        if (X_rowindex[p] == A_rowindex[s])
                        {
                            A_value[s] -= X_value[p] * U_value[k];
                            p++;
                        }
                        else
                        {
                            continue;
                        }
                    }
                }
        }

    }


#endif